"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.asAsyncSortedKeyValuesSync = void 0;
const asAsyncKeyMapSync_1 = require("./asAsyncKeyMapSync");
async function* asAsyncSortedKeyValuesSync(source, keySelector, ascending, comparer) {
    const map = await (0, asAsyncKeyMapSync_1.asAsyncKeyMapSync)(source, keySelector);
    const sortedKeys = [...map.keys()].sort(comparer ? comparer : undefined);
    if (ascending) {
        for (let i = 0; i < sortedKeys.length; i++) {
            yield map.get(sortedKeys[i]);
        }
    }
    else {
        for (let i = sortedKeys.length - 1; i >= 0; i--) {
            yield map.get(sortedKeys[i]);
        }
    }
}
exports.asAsyncSortedKeyValuesSync = asAsyncSortedKeyValuesSync;
