"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.chunk = void 0;
const BasicAsyncEnumerable_1 = require("../BasicAsyncEnumerable");
const shared_1 = require("../../shared");
const chunk = (source, size) => {
    if (size < 1) {
        throw new shared_1.ArgumentOutOfRangeException("index");
    }
    async function* iterator() {
        let yieldChunk = [];
        for await (const value of source) {
            yieldChunk.push(value);
            if (yieldChunk.length === size) {
                yield yieldChunk;
                yieldChunk = [];
            }
        }
        if (yieldChunk.length) {
            yield yieldChunk;
        }
    }
    return new BasicAsyncEnumerable_1.BasicAsyncEnumerable(iterator);
};
exports.chunk = chunk;
