"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.defaultIfEmpty = void 0;
const BasicAsyncEnumerable_1 = require("../BasicAsyncEnumerable");
const defaultIfEmpty = (source, defaultValue) => {
    async function* generator() {
        let found = false;
        for await (const value of source) {
            found = true;
            yield value;
        }
        if (!found) {
            yield defaultValue;
        }
    }
    return new BasicAsyncEnumerable_1.BasicAsyncEnumerable(generator);
};
exports.defaultIfEmpty = defaultIfEmpty;
