"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.distinct = void 0;
const shared_1 = require("../../shared");
const BasicAsyncEnumerable_1 = require("../BasicAsyncEnumerable");
const distinct = (source, comparer = shared_1.StrictEqualityComparer) => {
    async function* iterator() {
        const distinctElements = [];
        for await (const item of source) {
            const foundItem = distinctElements.find((x) => comparer(x, item));
            if (!foundItem) {
                distinctElements.push(item);
                yield item;
            }
        }
    }
    return new BasicAsyncEnumerable_1.BasicAsyncEnumerable(iterator);
};
exports.distinct = distinct;
