"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.distinctAsync = void 0;
const BasicAsyncEnumerable_1 = require("../BasicAsyncEnumerable");
const distinctAsync = (source, comparer) => {
    async function* iterator() {
        const distinctElements = [];
        outerLoop: for await (const item of source) {
            for (const distinctElement of distinctElements) {
                const found = await comparer(distinctElement, item);
                if (found) {
                    continue outerLoop;
                }
            }
            distinctElements.push(item);
            yield item;
        }
    }
    return new BasicAsyncEnumerable_1.BasicAsyncEnumerable(iterator);
};
exports.distinctAsync = distinctAsync;
