"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.exceptAsync = void 0;
const BasicAsyncEnumerable_1 = require("../BasicAsyncEnumerable");
const exceptAsync = (first, second, comparer) => {
    async function* iterator() {
        const secondArray = [];
        for await (const x of second) {
            secondArray.push(x);
        }
        for await (const firstItem of first) {
            let exists = false;
            for (let j = 0; j < secondArray.length; j++) {
                const secondItem = secondArray[j];
                if (await comparer(firstItem, secondItem) === true) {
                    exists = true;
                    break;
                }
            }
            if (exists === false) {
                yield firstItem;
            }
        }
    }
    return new BasicAsyncEnumerable_1.BasicAsyncEnumerable(iterator);
};
exports.exceptAsync = exceptAsync;
