"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.join = void 0;
const shared_1 = require("../../shared");
const BasicAsyncEnumerable_1 = require("../BasicAsyncEnumerable");
const join = (outer, inner, outerKeySelector, innerKeySelector, resultSelector, comparer = shared_1.StrictEqualityComparer) => {
    async function* iterator() {
        const innerArray = [];
        for await (const i of inner) {
            innerArray.push(i);
        }
        for await (const o of outer) {
            const outerKey = outerKeySelector(o);
            for (const i of innerArray) {
                const innerKey = innerKeySelector(i);
                if (comparer(outerKey, innerKey) === true) {
                    yield resultSelector(o, i);
                }
            }
        }
    }
    return new BasicAsyncEnumerable_1.BasicAsyncEnumerable(iterator);
};
exports.join = join;
