"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.lastAsync = void 0;
const shared_1 = require("../../shared");
const lastAsync = async (source, predicate) => {
    let last = null;
    for await (const value of source) {
        if (await predicate(value) === true) {
            last = value;
        }
    }
    if (!last) {
        throw new shared_1.InvalidOperationException(shared_1.ErrorString.NoMatch);
    }
    return last;
};
exports.lastAsync = lastAsync;
