"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.maxAsync = void 0;
const shared_1 = require("../../shared");
const maxAsync = async (source, selector) => {
    let max = null;
    for await (const item of source) {
        max = Math.max(max || Number.NEGATIVE_INFINITY, await selector(item));
    }
    if (max === null) {
        throw new shared_1.InvalidOperationException(shared_1.ErrorString.NoElements);
    }
    else {
        return max;
    }
};
exports.maxAsync = maxAsync;
