"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.minAsync = void 0;
const shared_1 = require("../../shared");
const minAsync = async (source, selector) => {
    let min = null;
    for await (const item of source) {
        min = Math.min(min || Number.POSITIVE_INFINITY, await selector(item));
    }
    if (min === null) {
        throw new shared_1.InvalidOperationException(shared_1.ErrorString.NoElements);
    }
    else {
        return min;
    }
};
exports.minAsync = minAsync;
