"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ofType = void 0;
const BasicAsyncEnumerable_1 = require("../BasicAsyncEnumerable");
const ofType = (source, type) => {
    const typeCheck = typeof type === "string" ?
        ((x) => typeof x === type) :
        ((x) => x instanceof type);
    async function* iterator() {
        for await (const item of source) {
            if (typeCheck(item)) {
                yield item;
            }
        }
    }
    return new BasicAsyncEnumerable_1.BasicAsyncEnumerable(iterator);
};
exports.ofType = ofType;
