"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.partitionAsync = void 0;
const partitionAsync = async (source, predicate) => {
    const fail = [];
    const pass = [];
    for await (const value of source) {
        if (await predicate(value) === true) {
            pass.push(value);
        }
        else {
            fail.push(value);
        }
    }
    return [pass, fail];
};
exports.partitionAsync = partitionAsync;
