"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.selectManyAsync = void 0;
const BasicAsyncEnumerable_1 = require("../BasicAsyncEnumerable");
const selectManyAsync = (source, selector) => {
    if (selector.length === 1) {
        const iterator = async function* () {
            for await (const value of source) {
                const many = await selector(value);
                for (const innerValue of many) {
                    yield innerValue;
                }
            }
        };
        return new BasicAsyncEnumerable_1.BasicAsyncEnumerable(iterator);
    }
    else {
        const iterator = async function* () {
            let index = 0;
            for await (const value of source) {
                const many = await selector(value, index);
                for (const innerValue of many) {
                    yield innerValue;
                }
                index++;
            }
        };
        return new BasicAsyncEnumerable_1.BasicAsyncEnumerable(iterator);
    }
};
exports.selectManyAsync = selectManyAsync;
