"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.singleOrDefaultAsync = void 0;
const shared_1 = require("../../shared");
const singleOrDefaultAsync = async (source, predicate) => {
    let hasValue = false;
    let singleValue = null;
    for await (const value of source) {
        if (await predicate(value)) {
            if (hasValue === true) {
                throw new shared_1.InvalidOperationException(shared_1.ErrorString.MoreThanOneMatchingElement);
            }
            else {
                hasValue = true;
                singleValue = value;
            }
        }
    }
    return singleValue;
};
exports.singleOrDefaultAsync = singleOrDefaultAsync;
