"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.take = void 0;
const BasicAsyncEnumerable_1 = require("../BasicAsyncEnumerable");
const take = (source, amount) => {
    async function* iterator() {
        let amountLeft = amount > 0 ? amount : 0;
        for await (const item of source) {
            if (amountLeft-- === 0) {
                break;
            }
            else {
                yield item;
            }
        }
    }
    return new BasicAsyncEnumerable_1.BasicAsyncEnumerable(iterator);
};
exports.take = take;
