"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.whereAsync = void 0;
const BasicAsyncEnumerable_1 = require("../BasicAsyncEnumerable");
const whereAsync = (source, predicate) => {
    if (predicate.length === 1) {
        return whereAsync1(source, predicate);
    }
    else {
        return whereAsync2(source, predicate);
    }
};
exports.whereAsync = whereAsync;
const whereAsync1 = (source, predicate) => {
    async function* iterator() {
        for await (const item of source) {
            if (await predicate(item) === true) {
                yield item;
            }
        }
    }
    return new BasicAsyncEnumerable_1.BasicAsyncEnumerable(iterator);
};
const whereAsync2 = (source, predicate) => {
    async function* iterator() {
        let i = 0;
        for await (const item of source) {
            if (await predicate(item, i++) === true) {
                yield item;
            }
        }
    }
    return new BasicAsyncEnumerable_1.BasicAsyncEnumerable(iterator);
};
