"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isAsyncEnumerable = void 0;
const BasicAsyncEnumerable_1 = require("./BasicAsyncEnumerable");
const isAsyncEnumerable = (source) => {
    if (!source) {
        return false;
    }
    if (source instanceof BasicAsyncEnumerable_1.BasicAsyncEnumerable) {
        return true;
    }
    if (typeof source[Symbol.asyncIterator] !== "function") {
        return false;
    }
    const propertyNames = Object.getOwnPropertyNames(BasicAsyncEnumerable_1.BasicAsyncEnumerable.prototype)
        .filter((v) => v !== "constructor");
    const methods = source.prototype || source;
    for (const prop of propertyNames) {
        if (typeof methods[prop] !== "function") {
            return false;
        }
    }
    return true;
};
exports.isAsyncEnumerable = isAsyncEnumerable;
