"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.rangeAsync = void 0;
const shared_1 = require("../../shared");
const BasicAsyncEnumerable_1 = require("../BasicAsyncEnumerable");
const rangeAsync = (start, count) => {
    if (start < 0 || (start + count - 1) > Number.MAX_SAFE_INTEGER) {
        throw new shared_1.ArgumentOutOfRangeException("start");
    }
    async function* iterator() {
        const max = start + count;
        for (let i = start; i < max; i++) {
            yield i;
        }
    }
    return new BasicAsyncEnumerable_1.BasicAsyncEnumerable(iterator);
};
exports.rangeAsync = rangeAsync;
