"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.repeatAsync = void 0;
const shared_1 = require("../../shared");
const BasicAsyncEnumerable_1 = require("../BasicAsyncEnumerable");
const repeatAsync = (element, count, delay) => {
    if (count < 0) {
        throw new shared_1.ArgumentOutOfRangeException("count");
    }
    if (delay) {
        return repeat2(element, count, delay);
    }
    else {
        return repeat1(element, count);
    }
};
exports.repeatAsync = repeatAsync;
const repeat1 = (element, count) => {
    async function* iterator() {
        for (let i = 0; i < count; i++) {
            yield element;
        }
    }
    return new BasicAsyncEnumerable_1.BasicAsyncEnumerable(iterator);
};
const repeat2 = (element, count, delay) => {
    async function* iterator() {
        for (let i = 0; i < count; i++) {
            yield await new Promise((resolve) => setTimeout(() => resolve(element), delay));
        }
    }
    return new BasicAsyncEnumerable_1.BasicAsyncEnumerable(iterator);
};
