"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.asAsyncSortedKeyValues = void 0;
const asAsyncKeyMap_1 = require("./asAsyncKeyMap");
async function* asAsyncSortedKeyValues(source, keySelector, ascending, comparer) {
    const map = await (0, asAsyncKeyMap_1.asAsyncKeyMap)(source, keySelector);
    const sortedKeys = [...map.keys()].sort(comparer ? comparer : undefined);
    if (ascending) {
        for (let i = 0; i < sortedKeys.length; i++) {
            yield map.get(sortedKeys[i]);
        }
    }
    else {
        for (let i = sortedKeys.length - 1; i >= 0; i--) {
            yield map.get(sortedKeys[i]);
        }
    }
}
exports.asAsyncSortedKeyValues = asAsyncSortedKeyValues;
