"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.all = void 0;
const _nextIteration_1 = require("./_nextIteration");
const all = (source, predicate) => {
    const nextIter = (0, _nextIteration_1.nextIteration)(source, (x) => {
        if (!predicate(x)) {
            throw new Error(String(false));
        }
        return true;
    });
    switch (nextIter.type) {
        case 0:
            return nextIter.generator()
                .then(() => true, () => false);
        case 1:
            return Promise.all(nextIter.generator())
                .then(() => true, () => false);
        case 2:
            return nextIter.generator()
                .then(Promise.all.bind(Promise))
                .then(() => true, () => false);
    }
};
exports.all = all;
