"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.allAsync = void 0;
const _nextIterationAsync_1 = require("./_nextIterationAsync");
const allAsync = (source, predicate) => {
    const nextIter = (0, _nextIterationAsync_1.nextIterationAsync)(source, async (x) => {
        if (await predicate(x) === false) {
            throw new Error(String(false));
        }
        return true;
    });
    switch (nextIter.type) {
        case 1:
            return Promise.all(nextIter.generator())
                .then(() => true, () => false);
        case 2:
            return nextIter.generator()
                .then(Promise.all.bind(Promise))
                .then(() => true, () => false);
    }
};
exports.allAsync = allAsync;
