"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.any = void 0;
const _nextIteration_1 = require("./_nextIteration");
const any = (source, predicate) => {
    if (predicate) {
        return any2(source, predicate);
    }
    else {
        return any1(source);
    }
};
exports.any = any;
const any1 = async (source) => {
    const dataFunc = source.dataFunc;
    let values;
    switch (dataFunc.type) {
        case 1:
            values = dataFunc.generator();
            return values.length !== 0;
        case 0:
        case 2:
            values = await dataFunc.generator();
            return values.length !== 0;
    }
};
const any2 = async (source, predicate) => {
    const dataFunc = (0, _nextIteration_1.nextIteration)(source, predicate);
    let values;
    switch (dataFunc.type) {
        case 0:
            values = await dataFunc.generator();
            return values.includes(true);
        case 1:
            values = await Promise.all(dataFunc.generator());
            return values.includes(true);
        case 2:
            values = await Promise.all(await dataFunc.generator());
            return values.includes(true);
    }
};
