"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.averageAsync = void 0;
const shared_1 = require("../../shared");
const _nextIterationAsync_1 = require("./_nextIterationAsync");
const _typeDataToArray_1 = require("./_typeDataToArray");
const averageAsync = async (source, selector) => {
    const nextIter = (0, _nextIterationAsync_1.nextIterationAsync)(source, selector);
    const values = await (0, _typeDataToArray_1.typeDataToArray)(nextIter);
    if (values.length === 0) {
        throw new shared_1.InvalidOperationException(shared_1.ErrorString.NoElements);
    }
    let value = 0;
    for (const selectedValue of values) {
        value += selectedValue;
    }
    return value / values.length;
};
exports.averageAsync = averageAsync;
