"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.countAsync = void 0;
const _nextIterationAsync_1 = require("./_nextIterationAsync");
const countAsync = async (source, predicate) => {
    const data = (0, _nextIterationAsync_1.nextIterationAsync)(source, predicate);
    let countPromise;
    switch (data.type) {
        case 1:
            countPromise = Promise.all(data.generator());
            break;
        case 2:
            countPromise = Promise.all(await data.generator());
            break;
    }
    let totalCount = 0;
    for (const value of await countPromise) {
        if (value) {
            totalCount++;
        }
    }
    return totalCount;
};
exports.countAsync = countAsync;
