"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.distinctAsync = void 0;
const BasicParallelEnumerable_1 = require("../BasicParallelEnumerable");
const distinctAsync = (source, comparer) => {
    const generator = async () => {
        const distinctElements = [];
        outerLoop: for (const item of await source.toArray()) {
            for (const distinctElement of distinctElements) {
                const found = await comparer(distinctElement, item);
                if (found) {
                    continue outerLoop;
                }
            }
            distinctElements.push(item);
        }
        return distinctElements;
    };
    return new BasicParallelEnumerable_1.BasicParallelEnumerable({
        generator,
        type: 0,
    });
};
exports.distinctAsync = distinctAsync;
