"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.elementAt = void 0;
const shared_1 = require("../../shared");
const elementAt = async (source, index) => {
    if (index < 0) {
        throw new shared_1.ArgumentOutOfRangeException("index");
    }
    const dataFunc = source.dataFunc;
    switch (dataFunc.type) {
        case 0: {
            const values = await dataFunc.generator();
            if (index >= values.length) {
                throw new shared_1.ArgumentOutOfRangeException("index");
            }
            else {
                return values[index];
            }
        }
        case 1: {
            const promises = dataFunc.generator();
            if (index >= promises.length) {
                throw new shared_1.ArgumentOutOfRangeException("index");
            }
            else {
                return await promises[index];
            }
        }
        case 2: {
            const promises = await dataFunc.generator();
            if (index >= promises.length) {
                throw new shared_1.ArgumentOutOfRangeException("index");
            }
            else {
                return await promises[index];
            }
        }
    }
};
exports.elementAt = elementAt;
