"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.exceptAsync = void 0;
const BasicParallelEnumerable_1 = require("../BasicParallelEnumerable");
const exceptAsync = (first, second, comparer) => {
    const generator = async () => {
        const [firstValues, secondValues] = await Promise.all([first.toArray(), second.toArray()]);
        const resultValues = [];
        for (const firstItem of firstValues) {
            let exists = false;
            for (let j = 0; j < secondValues.length; j++) {
                const secondItem = secondValues[j];
                if (await comparer(firstItem, secondItem) === true) {
                    exists = true;
                    break;
                }
            }
            if (exists === false) {
                resultValues.push(firstItem);
            }
        }
        return resultValues;
    };
    return new BasicParallelEnumerable_1.BasicParallelEnumerable({
        generator,
        type: 0,
    });
};
exports.exceptAsync = exceptAsync;
