"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.firstAsync = void 0;
const shared_1 = require("../../shared");
const toArray_1 = require("./toArray");
const firstAsync = async (source, predicate) => {
    const data = await (0, toArray_1.toArray)(source);
    for (const value of data) {
        if (await predicate(value) === true) {
            return value;
        }
    }
    throw new shared_1.InvalidOperationException(shared_1.ErrorString.NoMatch);
};
exports.firstAsync = firstAsync;
