"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.maxAsync = void 0;
const shared_1 = require("../../shared");
const _nextIterationAsync_1 = require("./_nextIterationAsync");
const _typeDataToArray_1 = require("./_typeDataToArray");
const maxAsync = async (source, selector) => {
    const dataFunc = (0, _nextIterationAsync_1.nextIterationAsync)(source, selector);
    const maxInfo = await (0, _typeDataToArray_1.typeDataToArray)(dataFunc);
    if (maxInfo.length === 0) {
        throw new shared_1.InvalidOperationException(shared_1.ErrorString.NoElements);
    }
    return Math.max.apply(null, maxInfo);
};
exports.maxAsync = maxAsync;
