"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.selectManyAsync = void 0;
const BasicParallelEnumerable_1 = require("../BasicParallelEnumerable");
const _nextIterationAsync_1 = require("./_nextIterationAsync");
const _nextIterationWithIndexAsync_1 = require("./_nextIterationWithIndexAsync");
const selectManyAsync = (source, selector) => {
    const generator = async () => {
        let values;
        if (selector.length === 1) {
            values = (0, _nextIterationAsync_1.nextIterationAsync)(source, selector);
        }
        else {
            values = (0, _nextIterationWithIndexAsync_1.nextIterationWithIndexAsync)(source, selector);
        }
        const valuesArray = [];
        switch (values.type) {
            case 1: {
                for (const outer of values.generator()) {
                    for (const y of await outer) {
                        valuesArray.push(y);
                    }
                }
                break;
            }
            case 2: {
                for (const outer of await values.generator()) {
                    for (const y of await outer) {
                        valuesArray.push(y);
                    }
                }
                break;
            }
        }
        return valuesArray;
    };
    return new BasicParallelEnumerable_1.BasicParallelEnumerable({
        generator,
        type: 0,
    });
};
exports.selectManyAsync = selectManyAsync;
