"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.singleOrDefaultAsync = void 0;
const shared_1 = require("../../shared");
const toArray_1 = require("./toArray");
const singleOrDefaultAsync = async (source, predicate) => {
    const results = await (0, toArray_1.toArray)(source);
    let hasValue = false;
    let singleValue = null;
    for (const value of results) {
        if (await predicate(value) === true) {
            if (hasValue === true) {
                throw new shared_1.InvalidOperationException(shared_1.ErrorString.MoreThanOneElement);
            }
            else {
                hasValue = true;
                singleValue = value;
            }
        }
    }
    return singleValue;
};
exports.singleOrDefaultAsync = singleOrDefaultAsync;
