"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.skip = void 0;
const BasicParallelEnumerable_1 = require("../BasicParallelEnumerable");
const skip = (source, count) => {
    const dataFunc = source.dataFunc;
    switch (dataFunc.type) {
        case 0: {
            const generator = async () => (await dataFunc.generator()).slice(count);
            return new BasicParallelEnumerable_1.BasicParallelEnumerable({
                generator,
                type: 0,
            });
        }
        case 1: {
            const generator = () => dataFunc.generator().slice(count);
            return new BasicParallelEnumerable_1.BasicParallelEnumerable({
                generator,
                type: 1,
            });
        }
        case 2: {
            const generator = async () => {
                const dataInner = await dataFunc.generator();
                return dataInner.slice(count);
            };
            const dataFuncNew = {
                generator,
                type: 2,
            };
            return new BasicParallelEnumerable_1.BasicParallelEnumerable(dataFuncNew);
        }
    }
};
exports.skip = skip;
