"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toMapAsync = void 0;
const _nextIterationAsync_1 = require("./_nextIterationAsync");
const _typeDataToArray_1 = require("./_typeDataToArray");
const toMapAsync = async (source, selector) => {
    const map = new Map();
    const dataFunc = (0, _nextIterationAsync_1.nextIterationAsync)(source, async (value) => {
        const key = await selector(value);
        return [key, value];
    });
    const keyValues = await (0, _typeDataToArray_1.typeDataToArray)(dataFunc);
    for (const [key, value] of keyValues) {
        const array = map.get(key);
        if (array === undefined) {
            map.set(key, [value]);
        }
        else {
            array.push(value);
        }
    }
    return map;
};
exports.toMapAsync = toMapAsync;
