"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isParallelEnumerable = void 0;
const BasicParallelEnumerable_1 = require("./BasicParallelEnumerable");
const isParallelEnumerable = (source) => {
    if (!source) {
        return false;
    }
    if (source instanceof BasicParallelEnumerable_1.BasicParallelEnumerable) {
        return true;
    }
    if (typeof source[Symbol.asyncIterator] !== "function") {
        return false;
    }
    const propertyNames = Object.getOwnPropertyNames(BasicParallelEnumerable_1.BasicParallelEnumerable.prototype)
        .filter((v) => v !== "constructor");
    const methods = source.prototype || source;
    for (const prop of propertyNames) {
        if (typeof methods[prop] !== "function") {
            return false;
        }
    }
    return true;
};
exports.isParallelEnumerable = isParallelEnumerable;
