"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.rangeParallel = void 0;
const shared_1 = require("../../shared");
const BasicParallelEnumerable_1 = require("../BasicParallelEnumerable");
const rangeParallel = (start, count) => {
    if (start < 0 || (start + count - 1) > Number.MAX_SAFE_INTEGER) {
        throw new shared_1.ArgumentOutOfRangeException("start");
    }
    const generator = () => {
        const items = [];
        const maxI = start + count;
        for (let i = start; i < maxI; i++) {
            items.push(Promise.resolve(i));
        }
        return items;
    };
    return new BasicParallelEnumerable_1.BasicParallelEnumerable({
        generator,
        type: 1,
    });
};
exports.rangeParallel = rangeParallel;
