"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.asSortedKeyValuesAsync = void 0;
const asKeyMapAsync_1 = require("./asKeyMapAsync");
async function* asSortedKeyValuesAsync(source, keySelector, ascending, comparer) {
    const map = await (0, asKeyMapAsync_1.asKeyMapAsync)(source, keySelector);
    const sortedKeys = [...map.keys()].sort(comparer ? comparer : undefined);
    if (ascending) {
        for (let i = 0; i < sortedKeys.length; i++) {
            yield map.get(sortedKeys[i]);
        }
    }
    else {
        for (let i = sortedKeys.length - 1; i >= 0; i--) {
            yield map.get(sortedKeys[i]);
        }
    }
}
exports.asSortedKeyValuesAsync = asSortedKeyValuesAsync;
