"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.chunk = void 0;
const BasicEnumerable_1 = require("../BasicEnumerable");
const shared_1 = require("../../shared");
const chunk = (source, size) => {
    if (size < 1) {
        throw new shared_1.ArgumentOutOfRangeException("index");
    }
    function* iterator() {
        let yieldChunk = [];
        for (const value of source) {
            yieldChunk.push(value);
            if (yieldChunk.length === size) {
                yield yieldChunk;
                yieldChunk = [];
            }
        }
        if (yieldChunk.length) {
            yield yieldChunk;
        }
    }
    return new BasicEnumerable_1.BasicEnumerable(iterator);
};
exports.chunk = chunk;
