"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.defaultIfEmpty = void 0;
const BasicEnumerable_1 = require("../BasicEnumerable");
const defaultIfEmpty = (source, defaultValue) => {
    function* generator() {
        let found = false;
        for (const value of source) {
            found = true;
            yield value;
        }
        if (!found) {
            yield defaultValue;
        }
    }
    return new BasicEnumerable_1.BasicEnumerable(generator);
};
exports.defaultIfEmpty = defaultIfEmpty;
