"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.groupByWithResultAndSelector = void 0;
const shared_1 = require("../../shared");
const BasicEnumerable_1 = require("../BasicEnumerable");
const groupByShared_1 = require("./groupByShared");
const groupByWithResultAndSelector = (source, keySelector, elementSelector, resultSelector, comparer) => {
    if (comparer) {
        return groupBy3(source, keySelector, elementSelector, resultSelector);
    }
    else {
        return groupBy3Simple(source, keySelector, elementSelector, resultSelector);
    }
};
exports.groupByWithResultAndSelector = groupByWithResultAndSelector;
const groupBy3Simple = (source, keySelector, elementSelector, resultSelector) => {
    function* iterator() {
        const groupByResult = (0, groupByShared_1.groupBy_1_Simple)(source, keySelector, elementSelector);
        for (const group of groupByResult) {
            yield resultSelector(group.key, group);
        }
    }
    return new BasicEnumerable_1.BasicEnumerable(iterator);
};
const groupBy3 = (source, keySelector, elementSelector, resultSelector, comparer = shared_1.StrictEqualityComparer) => {
    function* iterator() {
        const groupByResult = (0, groupByShared_1.groupBy_1)(source, keySelector, elementSelector, comparer);
        for (const group of groupByResult) {
            yield resultSelector(group.key, group);
        }
    }
    return new BasicEnumerable_1.BasicEnumerable(iterator);
};
