"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.intersectAsync = void 0;
const fromAsync_1 = require("../../async/static/fromAsync");
const intersectAsync = (first, second, comparer) => {
    async function* iterator() {
        const firstResults = [];
        for await (const item of first.distinctAsync(comparer)) {
            firstResults.push(item);
        }
        if (firstResults.length === 0) {
            return;
        }
        const secondResults = [...second];
        for (let i = 0; i < firstResults.length; i++) {
            const firstValue = firstResults[i];
            for (let j = 0; j < secondResults.length; j++) {
                const secondValue = secondResults[j];
                if (await comparer(firstValue, secondValue) === true) {
                    yield firstValue;
                    break;
                }
            }
        }
    }
    return (0, fromAsync_1.fromAsync)(iterator);
};
exports.intersectAsync = intersectAsync;
