"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.last = void 0;
const shared_1 = require("../../shared");
const last = (source, predicate) => {
    if (predicate) {
        return last2(source, predicate);
    }
    else {
        return last1(source);
    }
};
exports.last = last;
const last1 = (source) => {
    let lastItem;
    for (const value of source) {
        lastItem = value;
    }
    if (!lastItem) {
        throw new shared_1.InvalidOperationException(shared_1.ErrorString.NoElements);
    }
    return lastItem;
};
const last2 = (source, predicate) => {
    let lastItem;
    for (const value of source) {
        if (predicate(value) === true) {
            lastItem = value;
        }
    }
    if (!lastItem) {
        throw new shared_1.InvalidOperationException(shared_1.ErrorString.NoMatch);
    }
    return lastItem;
};
