"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.sequenceEquals = void 0;
const shared_1 = require("../../shared");
const sequenceEquals = (first, second, comparer = shared_1.StrictEqualityComparer) => {
    const firstIterator = first[Symbol.iterator]();
    const secondIterator = second[Symbol.iterator]();
    let firstResult = firstIterator.next();
    let secondResult = secondIterator.next();
    while (!firstResult.done && !secondResult.done) {
        if (!comparer(firstResult.value, secondResult.value)) {
            return false;
        }
        firstResult = firstIterator.next();
        secondResult = secondIterator.next();
    }
    return firstResult.done === true && secondResult.done === true;
};
exports.sequenceEquals = sequenceEquals;
