"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.unionAsync = void 0;
const fromAsync_1 = require("../../async/static/fromAsync");
const unionAsync = (first, second, comparer) => {
    async function* iterator() {
        const result = [];
        for (const source of [first, second]) {
            for (const value of source) {
                let exists = false;
                for (const resultValue of result) {
                    if (await comparer(value, resultValue) === true) {
                        exists = true;
                        break;
                    }
                }
                if (exists === false) {
                    yield value;
                    result.push(value);
                }
            }
        }
    }
    return (0, fromAsync_1.fromAsync)(iterator);
};
exports.unionAsync = unionAsync;
