"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.zipAsync = void 0;
const fromAsync_1 = require("../../async/static/fromAsync");
const zipAsync = (first, second, resultSelector) => {
    async function* generator() {
        const firstIterator = first[Symbol.iterator]();
        const secondIterator = second[Symbol.iterator]();
        while (true) {
            const a = firstIterator.next();
            const b = secondIterator.next();
            if (a.done || b.done) {
                break;
            }
            else {
                yield resultSelector(a.value, b.value);
            }
        }
    }
    return (0, fromAsync_1.fromAsync)(generator);
};
exports.zipAsync = zipAsync;
