"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isEnumerable = void 0;
const ArrayEnumerable_1 = require("./ArrayEnumerable");
const BasicEnumerable_1 = require("./BasicEnumerable");
const isEnumerable = (source) => {
    if (!source) {
        return false;
    }
    if (source instanceof BasicEnumerable_1.BasicEnumerable) {
        return true;
    }
    if (source instanceof ArrayEnumerable_1.ArrayEnumerable) {
        return true;
    }
    if (typeof source[Symbol.iterator] !== "function") {
        return false;
    }
    const propertyNames = Object.getOwnPropertyNames(BasicEnumerable_1.BasicEnumerable.prototype)
        .filter((v) => v !== "constructor");
    const methods = source.prototype || source;
    for (const prop of propertyNames) {
        if (typeof methods[prop] !== "function") {
            return false;
        }
    }
    return true;
};
exports.isEnumerable = isEnumerable;
