"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.flatten = void 0;
const BasicEnumerable_1 = require("../BasicEnumerable");
const flatten = (source, shallow) => {
    function* iterator(source) {
        for (const item of source) {
            if (item[Symbol.iterator] !== undefined && typeof item !== "string") {
                yield* shallow ? item : iterator(item);
            }
            else {
                yield item;
            }
        }
    }
    return new BasicEnumerable_1.BasicEnumerable(() => iterator(source));
};
exports.flatten = flatten;
