"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.repeat = void 0;
const shared_1 = require("../../shared");
const BasicEnumerable_1 = require("../BasicEnumerable");
const repeat = (element, count) => {
    if (count < 0) {
        throw new shared_1.ArgumentOutOfRangeException("count");
    }
    function* iterator() {
        for (let i = 0; i < count; i++) {
            yield element;
        }
    }
    return new BasicEnumerable_1.BasicEnumerable(iterator);
};
exports.repeat = repeat;
